<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classVertexBase-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__data__structures.html">Data Structures</a> &#124; <a class="el" href="group__core.html">Core Classes</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>core vertex class  
 <a href="classVertexBase.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglContainersVertexBase_8hpp_source.html">tiglContainersVertexBase.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classVertexBase.png" usemap="#TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;_map" alt=""/>
  <map id="TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;_map" name="TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;_map">
<area href="classBiVertexBase.html" title="A vertex class with both input and output edges lists. " alt="TIGLContainersBiVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;" shape="rect" coords="0,56,508,80"/>
<area href="classTIGLApiVertex.html" title="core vertex class for the TIGL Engine (with only output edge buffer). " alt="TIGLApiVertex&lt; DataType, AlgDataType, EdgeType, InitType, IdType, MessageType &gt;" shape="rect" coords="518,56,1026,80"/>
<area href="classBiVertex.html" title="core vertex class with input and output edge buffers " alt="TIGLContainersBiVertex&lt; DataType, AlgDataType, EdgeType, IdType &gt;" shape="rect" coords="0,112,508,136"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:adb1a2b93398a600c6f3ec63b07b5d298"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#adb1a2b93398a600c6f3ec63b07b5d298">TIGLContainersVertexBase</a> (IdType key)</td></tr>
<tr class="memdesc:adb1a2b93398a600c6f3ec63b07b5d298"><td class="mdescLeft">&#160;</td><td class="mdescRight">constructor  <a href="#adb1a2b93398a600c6f3ec63b07b5d298">More...</a><br /></td></tr>
<tr class="separator:adb1a2b93398a600c6f3ec63b07b5d298"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd0ed7e9119b24c396140cfdfdd680aa"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#afd0ed7e9119b24c396140cfdfdd680aa">TIGLContainersVertexBase</a> (IdType key, DataType data, AlgDataType alg)</td></tr>
<tr class="memdesc:afd0ed7e9119b24c396140cfdfdd680aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">constructor  <a href="#afd0ed7e9119b24c396140cfdfdd680aa">More...</a><br /></td></tr>
<tr class="separator:afd0ed7e9119b24c396140cfdfdd680aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af14b55996c13b084fdf5f33f42264ff1"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af14b55996c13b084fdf5f33f42264ff1"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#af14b55996c13b084fdf5f33f42264ff1">TIGLContainersVertexBase</a> ()</td></tr>
<tr class="memdesc:af14b55996c13b084fdf5f33f42264ff1"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded empty constructor <br /></td></tr>
<tr class="separator:af14b55996c13b084fdf5f33f42264ff1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25138dd4310e4e5e181fdc06d333b1b5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a25138dd4310e4e5e181fdc06d333b1b5"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a25138dd4310e4e5e181fdc06d333b1b5">operator&lt;</a> (const <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt; &amp;rhs) const </td></tr>
<tr class="memdesc:a25138dd4310e4e5e181fdc06d333b1b5"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded operator for list ordering <br /></td></tr>
<tr class="separator:a25138dd4310e4e5e181fdc06d333b1b5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a837cba707df462ae475ae2d2f6bc1fb0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a837cba707df462ae475ae2d2f6bc1fb0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a837cba707df462ae475ae2d2f6bc1fb0">operator==</a> (const <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt; &amp;rhs) const </td></tr>
<tr class="memdesc:a837cba707df462ae475ae2d2f6bc1fb0"><td class="mdescLeft">&#160;</td><td class="mdescRight">overloaded equal operator for list ordering <br /></td></tr>
<tr class="separator:a837cba707df462ae475ae2d2f6bc1fb0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34eb81edd484f2c867317fa8020a70e8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a34eb81edd484f2c867317fa8020a70e8">addEdge</a> (EdgeType &amp;x)</td></tr>
<tr class="memdesc:a34eb81edd484f2c867317fa8020a70e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding output edge  <a href="#a34eb81edd484f2c867317fa8020a70e8">More...</a><br /></td></tr>
<tr class="separator:a34eb81edd484f2c867317fa8020a70e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abe5ac40c01303629cf1ded76fccd5fc9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#abe5ac40c01303629cf1ded76fccd5fc9">addEdge</a> (ID_TYPE &amp;target)</td></tr>
<tr class="memdesc:abe5ac40c01303629cf1ded76fccd5fc9"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding output edge (overloaded function)  <a href="#abe5ac40c01303629cf1ded76fccd5fc9">More...</a><br /></td></tr>
<tr class="separator:abe5ac40c01303629cf1ded76fccd5fc9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a74baae25363b379b03e47cdb980ff6a1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a74baae25363b379b03e47cdb980ff6a1">addEdge</a> (OUT_EDGE_BUF &amp;x)</td></tr>
<tr class="memdesc:a74baae25363b379b03e47cdb980ff6a1"><td class="mdescLeft">&#160;</td><td class="mdescRight">adding multiple ouput edges  <a href="#a74baae25363b379b03e47cdb980ff6a1">More...</a><br /></td></tr>
<tr class="separator:a74baae25363b379b03e47cdb980ff6a1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab006f12fd9aeec205ea897c20e59510c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#ab006f12fd9aeec205ea897c20e59510c">removeEdge</a> (IdType &amp;target)</td></tr>
<tr class="memdesc:ab006f12fd9aeec205ea897c20e59510c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Removing an output edge identified by target node.  <a href="#ab006f12fd9aeec205ea897c20e59510c">More...</a><br /></td></tr>
<tr class="separator:ab006f12fd9aeec205ea897c20e59510c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a998b9ff387f81cf03698afc0f03d285d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a998b9ff387f81cf03698afc0f03d285d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a998b9ff387f81cf03698afc0f03d285d">clearEdges</a> ()</td></tr>
<tr class="memdesc:a998b9ff387f81cf03698afc0f03d285d"><td class="mdescLeft">&#160;</td><td class="mdescRight">clear all output edges <br /></td></tr>
<tr class="separator:a998b9ff387f81cf03698afc0f03d285d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2ee1c3555c41d6c5d5158c7db87e553"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa2ee1c3555c41d6c5d5158c7db87e553"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#aa2ee1c3555c41d6c5d5158c7db87e553">getNumOutEdges</a> ()</td></tr>
<tr class="memdesc:aa2ee1c3555c41d6c5d5158c7db87e553"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the total number of output edges <br /></td></tr>
<tr class="separator:aa2ee1c3555c41d6c5d5158c7db87e553"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a093103af72a37ba4f79cb3a8795d7bac"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a093103af72a37ba4f79cb3a8795d7bac"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a093103af72a37ba4f79cb3a8795d7bac">getNumDifferentNbr</a> ()</td></tr>
<tr class="memdesc:a093103af72a37ba4f79cb3a8795d7bac"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the number of neigbors excluding self (i.e., ignoring self cycles) <br /></td></tr>
<tr class="separator:a093103af72a37ba4f79cb3a8795d7bac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a020e6811758e3aa6dbfca82a5032ef8e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a020e6811758e3aa6dbfca82a5032ef8e">getChildren</a> (vector&lt; IdType &gt; &amp;vectChildren)</td></tr>
<tr class="memdesc:a020e6811758e3aa6dbfca82a5032ef8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the vertex id of all children  <a href="#a020e6811758e3aa6dbfca82a5032ef8e">More...</a><br /></td></tr>
<tr class="separator:a020e6811758e3aa6dbfca82a5032ef8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64bf2204455cd6fcfbe09250bfb5ce8e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a64bf2204455cd6fcfbe09250bfb5ce8e">isConnected</a> (IdType node)</td></tr>
<tr class="memdesc:a64bf2204455cd6fcfbe09250bfb5ce8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if a given node is connected to the current node  <a href="#a64bf2204455cd6fcfbe09250bfb5ce8e">More...</a><br /></td></tr>
<tr class="separator:a64bf2204455cd6fcfbe09250bfb5ce8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5518145dfac6cccf6a953844db832437"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5518145dfac6cccf6a953844db832437"></a>
DataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a5518145dfac6cccf6a953844db832437">get_value</a> ()</td></tr>
<tr class="memdesc:a5518145dfac6cccf6a953844db832437"><td class="mdescLeft">&#160;</td><td class="mdescRight">return the vertex data field <br /></td></tr>
<tr class="separator:a5518145dfac6cccf6a953844db832437"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a507b6bc82839feae98ad222affa1c6bd"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a507b6bc82839feae98ad222affa1c6bd"></a>
AlgDataType &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a507b6bc82839feae98ad222affa1c6bd">getAlgData</a> ()</td></tr>
<tr class="memdesc:a507b6bc82839feae98ad222affa1c6bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the algorithm data <br /></td></tr>
<tr class="separator:a507b6bc82839feae98ad222affa1c6bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80eb6cd8ce4211480a2a14690701142f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a80eb6cd8ce4211480a2a14690701142f"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a80eb6cd8ce4211480a2a14690701142f">getId</a> ()</td></tr>
<tr class="memdesc:a80eb6cd8ce4211480a2a14690701142f"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns the vertex id <br /></td></tr>
<tr class="separator:a80eb6cd8ce4211480a2a14690701142f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad400ab868eb9d01dc4a54eecdd42af80"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ad400ab868eb9d01dc4a54eecdd42af80"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#ad400ab868eb9d01dc4a54eecdd42af80">getBeginOutEdgeIterator</a> ()</td></tr>
<tr class="memdesc:ad400ab868eb9d01dc4a54eecdd42af80"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to the start of the outEdges buffer <br /></td></tr>
<tr class="separator:ad400ab868eb9d01dc4a54eecdd42af80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1407b2b9e0feaa5673d4453a1f2b68f5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1407b2b9e0feaa5673d4453a1f2b68f5"></a>
OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a1407b2b9e0feaa5673d4453a1f2b68f5">getEndOutEdgeIterator</a> ()</td></tr>
<tr class="memdesc:a1407b2b9e0feaa5673d4453a1f2b68f5"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to the last edge of the outEdges buffer <br /></td></tr>
<tr class="separator:a1407b2b9e0feaa5673d4453a1f2b68f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8d95b1a399f35f2041ad3f427d607d8f"><td class="memItemLeft" align="right" valign="top">OUT_EDGE_ITERATOR&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a8d95b1a399f35f2041ad3f427d607d8f">get_edge</a> (ID_TYPE target)</td></tr>
<tr class="memdesc:a8d95b1a399f35f2041ad3f427d607d8f"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns an iterator to the output edge with a given target  <a href="#a8d95b1a399f35f2041ad3f427d607d8f">More...</a><br /></td></tr>
<tr class="separator:a8d95b1a399f35f2041ad3f427d607d8f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae4098c57f115e926e46c4fb48e8eff08"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#ae4098c57f115e926e46c4fb48e8eff08">isBiVertex</a> ()</td></tr>
<tr class="memdesc:ae4098c57f115e926e46c4fb48e8eff08"><td class="mdescLeft">&#160;</td><td class="mdescRight">check if the vertex type is <a class="el" href="classBiVertex.html" title="core vertex class with input and output edge buffers ">TIGLContainersBiVertex</a>  <a href="#ae4098c57f115e926e46c4fb48e8eff08">More...</a><br /></td></tr>
<tr class="separator:ae4098c57f115e926e46c4fb48e8eff08"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a417f8b88f76dad8f8b2d76841fade45c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a417f8b88f76dad8f8b2d76841fade45c"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a417f8b88f76dad8f8b2d76841fade45c">compute</a> (void *pIn=0, void *pOut=0)</td></tr>
<tr class="memdesc:a417f8b88f76dad8f8b2d76841fade45c"><td class="mdescLeft">&#160;</td><td class="mdescRight">core compute function: trivial realization in the core class. This function is overriden by the algorithm class <br /></td></tr>
<tr class="separator:a417f8b88f76dad8f8b2d76841fade45c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a458ade4c962b0e139837e736b5099cea"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a458ade4c962b0e139837e736b5099cea"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a458ade4c962b0e139837e736b5099cea">init</a> ()</td></tr>
<tr class="memdesc:a458ade4c962b0e139837e736b5099cea"><td class="mdescLeft">&#160;</td><td class="mdescRight">core init function: trivial realization in the core class. This function is overriden by the algorithm class <br /></td></tr>
<tr class="separator:a458ade4c962b0e139837e736b5099cea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b59a25cdae1065397cea8492f0decd3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7b59a25cdae1065397cea8492f0decd3"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a7b59a25cdae1065397cea8492f0decd3">getEdgesSize</a> ()</td></tr>
<tr class="memdesc:a7b59a25cdae1065397cea8492f0decd3"><td class="mdescLeft">&#160;</td><td class="mdescRight">returns memory usage for edges <br /></td></tr>
<tr class="separator:a7b59a25cdae1065397cea8492f0decd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a68eb54bdc5fc2b3af1396af8e78fda05"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a68eb54bdc5fc2b3af1396af8e78fda05"></a>
IdType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a68eb54bdc5fc2b3af1396af8e78fda05">id</a></td></tr>
<tr class="memdesc:a68eb54bdc5fc2b3af1396af8e78fda05"><td class="mdescLeft">&#160;</td><td class="mdescRight">unique vertex ID <br /></td></tr>
<tr class="separator:a68eb54bdc5fc2b3af1396af8e78fda05"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acfa725b9d37b7b7db14b070df9eb6be9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acfa725b9d37b7b7db14b070df9eb6be9"></a>
DataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#acfa725b9d37b7b7db14b070df9eb6be9">vertexData</a></td></tr>
<tr class="memdesc:acfa725b9d37b7b7db14b070df9eb6be9"><td class="mdescLeft">&#160;</td><td class="mdescRight">associated generic data <br /></td></tr>
<tr class="separator:acfa725b9d37b7b7db14b070df9eb6be9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1194c063341fb9886a4836d30baaec86"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1194c063341fb9886a4836d30baaec86"></a>
AlgDataType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a1194c063341fb9886a4836d30baaec86">algData</a></td></tr>
<tr class="memdesc:a1194c063341fb9886a4836d30baaec86"><td class="mdescLeft">&#160;</td><td class="mdescRight">Algorithm-specific data. <br /></td></tr>
<tr class="separator:a1194c063341fb9886a4836d30baaec86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a73d57311fa56ef50a2d49ac4002d534c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a73d57311fa56ef50a2d49ac4002d534c"></a>
OUT_EDGE_BUF&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classVertexBase.html#a73d57311fa56ef50a2d49ac4002d534c">outEdges</a></td></tr>
<tr class="memdesc:a73d57311fa56ef50a2d49ac4002d534c"><td class="mdescLeft">&#160;</td><td class="mdescRight">output edge buffer <br /></td></tr>
<tr class="separator:a73d57311fa56ef50a2d49ac4002d534c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt;<br />
class TIGLContainersVertexBase&lt; DataType, AlgDataType, EdgeType, IdType &gt;</h3>

<p>core vertex class </p>
<p>It contains all the vertex data and defines all vertex mutations It is a template class that is parameterized by the following parameters </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">DataType</td><td>the type of the data field in the vertex </td></tr>
    <tr><td class="paramname">AlgDataType</td><td>the type of algorithm data filed in the vertex </td></tr>
    <tr><td class="paramname">EdgeType</td><td>the edge type </td></tr>
    <tr><td class="paramname">IdType</td><td>the data type of the ID field of each vertex </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="adb1a2b93398a600c6f3ec63b07b5d298"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::<a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>constructor </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>the vertex ID </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="afd0ed7e9119b24c396140cfdfdd680aa"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::<a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a> </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">DataType&#160;</td>
          <td class="paramname"><em>data</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">AlgDataType&#160;</td>
          <td class="paramname"><em>alg</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>constructor </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">key</td><td>the vertex ID </td></tr>
    <tr><td class="paramname">data</td><td>initial value of vertexData field </td></tr>
    <tr><td class="paramname">alg</td><td>initial value of algData field </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a34eb81edd484f2c867317fa8020a70e8"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::addEdge </td>
          <td>(</td>
          <td class="paramtype">EdgeType &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>adding output edge </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>the edge object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="abe5ac40c01303629cf1ded76fccd5fc9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::addEdge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE &amp;&#160;</td>
          <td class="paramname"><em>target</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>adding output edge (overloaded function) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>the other side of the edge </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a74baae25363b379b03e47cdb980ff6a1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::addEdge </td>
          <td>(</td>
          <td class="paramtype">OUT_EDGE_BUF &amp;&#160;</td>
          <td class="paramname"><em>x</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>adding multiple ouput edges </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>a buffer of the output edges </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a8d95b1a399f35f2041ad3f427d607d8f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">OUT_EDGE_ITERATOR <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::get_edge </td>
          <td>(</td>
          <td class="paramtype">ID_TYPE&#160;</td>
          <td class="paramname"><em>target</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>returns an iterator to the output edge with a given target </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>the ID of the other side of the edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>iterator to the output edge if the edge exists, and end of buffer if the edge does not exist </dd></dl>

</div>
</div>
<a class="anchor" id="a020e6811758e3aa6dbfca82a5032ef8e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::getChildren </td>
          <td>(</td>
          <td class="paramtype">vector&lt; IdType &gt; &amp;&#160;</td>
          <td class="paramname"><em>vectChildren</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>return the vertex id of all children </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vectChildren</td><td>the output vector </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae4098c57f115e926e46c4fb48e8eff08"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::isBiVertex </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if the vertex type is <a class="el" href="classBiVertex.html" title="core vertex class with input and output edge buffers ">TIGLContainersBiVertex</a> </p>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">false</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a64bf2204455cd6fcfbe09250bfb5ce8e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::isConnected </td>
          <td>(</td>
          <td class="paramtype">IdType&#160;</td>
          <td class="paramname"><em>node</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>check if a given node is connected to the current node </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">node</td><td>ID of the other node </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if connected, false if not connected </dd></dl>

</div>
</div>
<a class="anchor" id="ab006f12fd9aeec205ea897c20e59510c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename DataType, typename AlgDataType, typename EdgeType, typename IdType = uint_fast32_t&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classVertexBase.html">TIGLContainersVertexBase</a>&lt; DataType, AlgDataType, EdgeType, IdType &gt;::removeEdge </td>
          <td>(</td>
          <td class="paramtype">IdType &amp;&#160;</td>
          <td class="paramname"><em>target</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Removing an output edge identified by target node. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">target</td><td>the other side of the edge </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if successful, false if the edge does not exit </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/home/mohamed/code/tigl/src/common/containers/<a class="el" href="tiglContainersVertexBase_8hpp_source.html">tiglContainersVertexBase.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Mar 3 2015 18:17:04 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
